Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/barber/barber.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -51,5 +51,5 @@
 #define NAME  "barber"
 
-#define FRAMES  30
+#define FRAMES  IMAGES
 
 #define MIN_FPS  1
@@ -99,38 +99,8 @@
 static bool decode_frames(void)
 {
-	frames[0] = decode_tga_gz((void *) frame01_tga_gz, frame01_tga_gz_size, 0);
-	frames[1] = decode_tga_gz((void *) frame02_tga_gz, frame02_tga_gz_size, 0);
-	frames[2] = decode_tga_gz((void *) frame03_tga_gz, frame03_tga_gz_size, 0);
-	frames[3] = decode_tga_gz((void *) frame04_tga_gz, frame04_tga_gz_size, 0);
-	frames[4] = decode_tga_gz((void *) frame05_tga_gz, frame05_tga_gz_size, 0);
-	frames[5] = decode_tga_gz((void *) frame06_tga_gz, frame06_tga_gz_size, 0);
-	frames[6] = decode_tga_gz((void *) frame07_tga_gz, frame07_tga_gz_size, 0);
-	frames[7] = decode_tga_gz((void *) frame08_tga_gz, frame08_tga_gz_size, 0);
-	frames[8] = decode_tga_gz((void *) frame09_tga_gz, frame09_tga_gz_size, 0);
-	frames[9] = decode_tga_gz((void *) frame10_tga_gz, frame10_tga_gz_size, 0);
-	frames[10] = decode_tga_gz((void *) frame11_tga_gz, frame11_tga_gz_size, 0);
-	frames[11] = decode_tga_gz((void *) frame12_tga_gz, frame12_tga_gz_size, 0);
-	frames[12] = decode_tga_gz((void *) frame13_tga_gz, frame13_tga_gz_size, 0);
-	frames[13] = decode_tga_gz((void *) frame14_tga_gz, frame14_tga_gz_size, 0);
-	frames[14] = decode_tga_gz((void *) frame15_tga_gz, frame15_tga_gz_size, 0);
-	frames[15] = decode_tga_gz((void *) frame16_tga_gz, frame16_tga_gz_size, 0);
-	frames[16] = decode_tga_gz((void *) frame17_tga_gz, frame17_tga_gz_size, 0);
-	frames[17] = decode_tga_gz((void *) frame18_tga_gz, frame18_tga_gz_size, 0);
-	frames[18] = decode_tga_gz((void *) frame19_tga_gz, frame19_tga_gz_size, 0);
-	frames[19] = decode_tga_gz((void *) frame20_tga_gz, frame20_tga_gz_size, 0);
-	frames[20] = decode_tga_gz((void *) frame21_tga_gz, frame21_tga_gz_size, 0);
-	frames[21] = decode_tga_gz((void *) frame22_tga_gz, frame22_tga_gz_size, 0);
-	frames[22] = decode_tga_gz((void *) frame23_tga_gz, frame23_tga_gz_size, 0);
-	frames[23] = decode_tga_gz((void *) frame24_tga_gz, frame24_tga_gz_size, 0);
-	frames[24] = decode_tga_gz((void *) frame25_tga_gz, frame25_tga_gz_size, 0);
-	frames[25] = decode_tga_gz((void *) frame26_tga_gz, frame26_tga_gz_size, 0);
-	frames[26] = decode_tga_gz((void *) frame27_tga_gz, frame27_tga_gz_size, 0);
-	frames[27] = decode_tga_gz((void *) frame28_tga_gz, frame28_tga_gz_size, 0);
-	frames[28] = decode_tga_gz((void *) frame29_tga_gz, frame29_tga_gz_size, 0);
-	frames[29] = decode_tga_gz((void *) frame30_tga_gz, frame30_tga_gz_size, 0);
-	
-	for (unsigned int frame = 0; frame < FRAMES; frame++) {
-		if (frames[frame] == NULL) {
-			printf("Unable to decode frame %u.\n", frame);
+	for (unsigned int i = 0; i < FRAMES; i++) {
+		frames[i] = decode_tga_gz(images[i].addr, images[i].size, 0);
+		if (frames[i] == NULL) {
+			printf("Unable to decode frame %u.\n", i);
 			return false;
 		}
Index: uspace/app/bdsh/cmds/builtin_cmds.c
===================================================================
--- uspace/app/bdsh/cmds/builtin_cmds.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/bdsh/cmds/builtin_cmds.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -79,8 +79,7 @@
 		return (char *)NULL;
 
-	for(i=0; builtin_aliases[i] != NULL; i++) {
+	for(i=0; builtin_aliases[i] != NULL; i+=2) {
 		if (!str_cmp(builtin_aliases[i], command))
-			return (char *)builtin_aliases[++i];
-		i++;
+			return (char *)builtin_aliases[i+1];
 	}
 
Index: uspace/app/bdsh/cmds/mod_cmds.c
===================================================================
--- uspace/app/bdsh/cmds/mod_cmds.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/bdsh/cmds/mod_cmds.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -96,8 +96,7 @@
 		return (char *)NULL;
 
-	for(i=0; mod_aliases[i] != NULL; i++) {
+	for(i=0; mod_aliases[i] != NULL; i+=2) {
 		if (!str_cmp(mod_aliases[i], command))
-			return (char *)mod_aliases[++i];
-		i++;
+			return (char *)mod_aliases[i+1];
 	}
 
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,4 @@
 #include <vfs/vfs.h>
 #include <str.h>
-#include <sort.h>
 
 #include "ls.h"
@@ -62,5 +61,5 @@
 static unsigned int ls_start(ls_job_t *);
 static void ls_print(struct dir_elem_t *);
-static int ls_cmp(void *, void *, void *);
+static int ls_cmp(const void *, const void *);
 static signed int ls_scan_dir(const char *, DIR *, struct dir_elem_t **);
 static unsigned int ls_recursive(const char *, DIR *);
@@ -104,12 +103,11 @@
  * @param a		Pointer to the structure of the first element.
  * @param b		Pointer to the structure of the second element.
- * @param arg		Pointer for an other and optionnal argument.
  *
  * @return		-1 if a < b, 1 otherwise.
  */
-static int ls_cmp(void *a, void *b, void *arg)
-{
-	struct dir_elem_t *da = a;
-	struct dir_elem_t *db = b;
+static int ls_cmp(const void *a, const void *b)
+{
+	struct dir_elem_t const *da = a;
+	struct dir_elem_t const *db = b;
 	
 	if ((da->s.is_directory && db->s.is_file) ||
@@ -191,10 +189,6 @@
 	}
 	
-	if (ls.sort) {
-		if (!qsort(&tosort[0], nbdirs, sizeof(struct dir_elem_t),
-		    ls_cmp, NULL)) {
-			printf("Sorting error.\n");
-		}
-	}
+	if (ls.sort)
+		qsort(&tosort[0], nbdirs, sizeof(struct dir_elem_t), ls_cmp);
 	
 	for (i = 0; i < nbdirs; i++)
Index: uspace/app/blkdump/blkdump.c
===================================================================
--- uspace/app/blkdump/blkdump.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/blkdump/blkdump.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -46,5 +46,5 @@
 #include <byteorder.h>
 #include <scsi/mmc.h>
-#include <sys/typefmt.h>
+#include <offset.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/bnchmark/bnchmark.c
===================================================================
--- uspace/app/bnchmark/bnchmark.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/bnchmark/bnchmark.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,4 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/devctl/devctl.c
===================================================================
--- uspace/app/devctl/devctl.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/devctl/devctl.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,9 +35,9 @@
 #include <devman.h>
 #include <errno.h>
+#include <io/table.h>
 #include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <str_error.h>
-#include <sys/typefmt.h>
 
 #define NAME "devctl"
@@ -206,4 +206,5 @@
 	size_t ndevs;
 	size_t i;
+	table_t *table = NULL;
 	int rc;
 
@@ -211,4 +212,13 @@
 	if (rc != EOK)
 		return rc;
+
+	rc = table_create(&table);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		goto out;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Driver\t" "Devs\t" "State\n");
 
 	for (i = 0; i < ndrvs; i++) {
@@ -227,11 +237,17 @@
 		sstate = drv_state_str(state);
 
-		printf("%-11s %3zu %s\n", sstate, ndevs, drv_name);
+		table_printf(table, "%s\t" "%zu\t" "%s\n", drv_name, ndevs, sstate);
 skip:
 		free(devs);
 	}
+
+	rc = table_print_out(table, stdout);
+	if (rc != EOK)
+		printf("Error printing driver table.\n");
+out:
 	free(drvs);
-
-	return EOK;
+	table_destroy(table);
+
+	return rc;
 }
 
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/df/df.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,5 +28,5 @@
 
 /** @addtogroup df
- * @brief Df utility.
+ * @brief Print amounts of free and used disk space.
  * @{
  */
@@ -35,4 +35,6 @@
  */
 
+#include <cap.h>
+#include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -46,19 +48,14 @@
 #define NAME  "df"
 
-#define HEADER_TABLE 	"Filesystem     %4u-blocks           Used      Available Used%% Mounted on"
-#define HEADER_TABLE_HR "Filesystem           Size           Used      Available Used%% Mounted on"
+#define HEADER_TABLE     "Filesystem           Size           Used      Available Used%% Mounted on"
+#define HEADER_TABLE_BLK "Filesystem  Blk. Size     Total        Used   Available Used%% Mounted on"
 
 #define PERCENTAGE(x, tot) (tot ? (100ULL * (x) / (tot)) : 0)
-#define FSBK_TO_BK(x, fsbk, bk) \
-	(((fsbk) != 0 && (fsbk) < (bk)) ? \
-		(unsigned long long) ((x) / ((bk) / (fsbk))) : \
-		(unsigned long long) ((x) * ((fsbk) / (bk))))
-
-static unsigned int unit_size;
-static unsigned int human_readable;
-
-static void size_to_human_readable(char *buf, uint64_t bytes);
+
+static bool display_blocks;
+
+static int size_to_human_readable(uint64_t, size_t, char **);
 static void print_header(void);
-static void print_statfs(struct statfs *, char *, char *);
+static int print_statfs(struct statfs *, char *, char *);
 static void print_usage(void);
 
@@ -67,23 +64,17 @@
 	int optres, errflg = 0;
 	struct statfs st;
-
-	unit_size = 512;
-	human_readable = 0;
-
-	/******************************************/
-	/*   Parse command line options...        */
-	/******************************************/
-	while ((optres = getopt(argc, argv, ":uhb:")) != -1) {
+	int rc;
+
+	display_blocks = false;
+
+	/* Parse command-line options */
+	while ((optres = getopt(argc, argv, ":ubh")) != -1) {
 		switch(optres) {
-		case 'u':
+		case 'h':
 			print_usage();
 			return 0;
 
-		case 'h':
-			human_readable = 1;
-			break;
-
 		case 'b':
-			str_uint32_t(optarg, NULL, 0, 0, &unit_size);
+			display_blocks = true;
 			break;
  
@@ -123,5 +114,7 @@
 	list_foreach(mtab_list, link, mtab_ent_t, mtab_ent) {
 		if (vfs_statfs_path(mtab_ent->mp, &st) == 0) {
-			print_statfs(&st, mtab_ent->fs_name, mtab_ent->mp);
+			rc = print_statfs(&st, mtab_ent->fs_name, mtab_ent->mp);
+			if (rc != EOK)
+				return 1;
 		} else {
 			fprintf(stderr, "Cannot get information for '%s' (%d).\n",
@@ -134,48 +127,53 @@
 }
 
-static void size_to_human_readable(char *buf, uint64_t bytes)
-{
-	const char *units = "BkMGTPEZY";
-	int i = 0;
-
-	while (bytes >= 1024) {
-		bytes /= 1024;
-		i++;
-	}
-
-	snprintf(buf, 6, "%4llu%c", (unsigned long long) bytes, units[i]);
+static int size_to_human_readable(uint64_t nblocks, size_t block_size, char **rptr)
+{
+	cap_spec_t cap;
+
+	cap_from_blocks(nblocks, block_size, &cap);
+	cap_simplify(&cap);
+	return cap_format(&cap, rptr);
 }
 
 static void print_header(void)
 {
-	if (human_readable)
-		printf(HEADER_TABLE_HR);
+	if (!display_blocks)
+		printf(HEADER_TABLE);
 	else
-		printf(HEADER_TABLE, unit_size);
+		printf(HEADER_TABLE_BLK);
 
 	putchar('\n');
 }
 
-static void print_statfs(struct statfs *st, char *name, char *mountpoint)
+static int print_statfs(struct statfs *st, char *name, char *mountpoint)
 {
 	uint64_t const used_blocks = st->f_blocks - st->f_bfree;
 	unsigned const perc_used = PERCENTAGE(used_blocks, st->f_blocks);
+	char *str;
+	int rc;
 
 	printf("%10s", name);
 
-	if (human_readable) {
-		char tmp[1024];
-
+	if (!display_blocks) {
 		/* Print size */
-		size_to_human_readable(tmp, st->f_blocks *  st->f_bsize);
-		printf(" %14s", tmp);
+		rc = size_to_human_readable(st->f_blocks, st->f_bsize, &str);
+		if (rc != EOK)
+			goto error;
+		printf(" %14s", str);
+		free(str);
 
 		/* Number of used blocks */
-		size_to_human_readable(tmp, used_blocks  *  st->f_bsize);
-		printf(" %14s", tmp);
+		rc = size_to_human_readable(used_blocks, st->f_bsize, &str);
+		if (rc != EOK)
+			goto error;
+		printf(" %14s", str);
+		free(str);
 
 		/* Number of available blocks */
-		size_to_human_readable(tmp, st->f_bfree *  st->f_bsize);
-		printf(" %14s", tmp);
+		rc = size_to_human_readable(st->f_bfree, st->f_bsize, &str);
+		if (rc != EOK)
+			goto error;
+		printf(" %14s", str);
+		free(str);
 
 		/* Percentage of used blocks */
@@ -185,22 +183,22 @@
 		printf(" %s\n", mountpoint);
 	} else {
-		/* Blocks / Used blocks / Available blocks / Used% / Mounted on */
-		printf(" %15llu %14llu %14llu %4u%% %s\n", 
-		    FSBK_TO_BK(st->f_blocks, st->f_bsize, unit_size),
-		    FSBK_TO_BK(used_blocks, st->f_bsize, unit_size),
-		    FSBK_TO_BK(st->f_bfree, st->f_bsize, unit_size),
-		    perc_used,
-		    mountpoint);
-	}
-
+		/* Block size / Blocks / Used blocks / Available blocks / Used% / Mounted on */
+		printf(" %10" PRIu32 " %9" PRIu64 " %11" PRIu64 " %11" PRIu64 " %4u%% %s\n", 
+		    st->f_bsize, st->f_blocks, used_blocks, st->f_bfree,
+		    perc_used, mountpoint);
+	}
+
+	return EOK;
+error:
+	printf("\nError: Out of memory.\n");
+	return ENOMEM;
 }
 
 static void print_usage(void)
 {
-	printf("syntax: %s [-u] [-h] [-b <size>] \n", NAME);
-	printf("  u : Show usage.\n");
-	printf("  h : \"Human-readable\" output.\n");
-	printf("  b : Scale block sizes by selected size.\n");
-	printf("\n");
+	printf("Syntax: %s [<options>] \n", NAME);
+	printf("Options:\n");
+	printf("  -h Print help\n");
+	printf("  -b Print exact block sizes and numbers\n");
 }
 
Index: uspace/app/download/main.c
===================================================================
--- uspace/app/download/main.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/download/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -57,6 +57,6 @@
 static void syntax_print(void)
 {
-	fprintf(stderr, "Usage: download <url>\n");
-	fprintf(stderr, "  This will write the data to stdout, so you may want\n");
+	fprintf(stderr, "Usage: download [-o <outfile>] <url>\n");
+	fprintf(stderr, "  Without -o, data will be written to stdout, so you may want\n");
 	fprintf(stderr, "  to redirect the output, e.g.\n");
 	fprintf(stderr, "\n");
@@ -66,18 +66,55 @@
 int main(int argc, char *argv[])
 {
-	if (argc != 2) {
+	int i;
+	char *ofname = NULL;
+	FILE *ofile = NULL;
+	size_t buf_size = 4096;
+	void *buf = NULL;
+	uri_t *uri = NULL;
+	http_t *http = NULL;
+	int rc;
+
+	if (argc < 2) {
 		syntax_print();
-		return 2;
-	}
-	
-	uri_t *uri = uri_parse(argv[1]);
+		rc = EINVAL;
+		goto error;
+	}
+	
+	i = 1;
+	
+	if (str_cmp(argv[i], "-o") == 0) {
+		++i;
+		if (argc < i + 1) {
+			syntax_print();
+			rc = EINVAL;
+			goto error;
+		}
+		
+		ofname = argv[i++];
+		ofile = fopen(ofname, "wb");
+		if (ofile == NULL) {
+			fprintf(stderr, "Error creating '%s'.\n", ofname);
+			rc = EINVAL;
+			goto error;
+		}
+	}
+	
+	if (argc != i + 1) {
+		syntax_print();
+		rc = EINVAL;
+		goto error;
+	}
+	
+	uri = uri_parse(argv[i]);
 	if (uri == NULL) {
 		fprintf(stderr, "Failed parsing URI\n");
-		return 2;
+		rc = EINVAL;
+		goto error;
 	}
 	
 	if (!uri_validate(uri)) {
 		fprintf(stderr, "The URI is invalid\n");
-		return 2;
+		rc = EINVAL;
+		goto error;
 	}
 	
@@ -86,18 +123,21 @@
 	if (str_cmp(uri->scheme, "http") != 0) {
 		fprintf(stderr, "Only http scheme is supported at the moment\n");
-		return 2;
+		rc = EINVAL;
+		goto error;
 	}
 	
 	if (uri->host == NULL) {
 		fprintf(stderr, "host not set\n");
-		return 2;
+		rc = EINVAL;
+		goto error;
 	}
 	
 	uint16_t port = 80;
 	if (uri->port != NULL) {
-		int rc = str_uint16_t(uri->port, NULL, 10, true, &port);
+		rc = str_uint16_t(uri->port, NULL, 10, true, &port);
 		if (rc != EOK) {
 			fprintf(stderr, "Invalid port number: %s\n", uri->port);
-			return 2;
+			rc = EINVAL;
+			goto error;
 		}
 	}
@@ -111,14 +151,13 @@
 		if (server_path == NULL) {
 			fprintf(stderr, "Failed allocating path\n");
-			uri_destroy(uri);
-			return 3;
-		}
-	}
-	else {
-		int rc = asprintf(&server_path, "%s?%s", path, uri->query);
+			rc = ENOMEM;
+			goto error;
+		}
+	} else {
+		rc = asprintf(&server_path, "%s?%s", path, uri->query);
 		if (rc < 0) {
 			fprintf(stderr, "Failed allocating path\n");
-			uri_destroy(uri);
-			return 3;
+			rc = ENOMEM;
+			goto error;
 		}
 	}
@@ -128,13 +167,12 @@
 	if (req == NULL) {
 		fprintf(stderr, "Failed creating request\n");
-		uri_destroy(uri);
-		return 3;
-	}
-	
-	int rc = http_headers_append(&req->headers, "Host", uri->host);
+		rc = ENOMEM;
+		goto error;
+	}
+	
+	rc = http_headers_append(&req->headers, "Host", uri->host);
 	if (rc != EOK) {
 		fprintf(stderr, "Failed setting Host header: %s\n", str_error(rc));
-		uri_destroy(uri);
-		return rc;
+		goto error;
 	}
 	
@@ -142,13 +180,12 @@
 	if (rc != EOK) {
 		fprintf(stderr, "Failed creating User-Agent header: %s\n", str_error(rc));
-		uri_destroy(uri);
-		return rc;
-	}
-	
-	http_t *http = http_create(uri->host, port);
+		goto error;
+	}
+	
+	http = http_create(uri->host, port);
 	if (http == NULL) {
-		uri_destroy(uri);
 		fprintf(stderr, "Failed creating HTTP object\n");
-		return 3;
+		rc = ENOMEM;
+		goto error;
 	}
 	
@@ -156,6 +193,6 @@
 	if (rc != EOK) {
 		fprintf(stderr, "Failed connecting: %s\n", str_error(rc));
-		uri_destroy(uri);
-		return rc;
+		rc = EIO;
+		goto error;
 	}
 	
@@ -163,6 +200,6 @@
 	if (rc != EOK) {
 		fprintf(stderr, "Failed sending request: %s\n", str_error(rc));
-		uri_destroy(uri);
-		return rc;
+		rc = EIO;
+		goto error;
 	}
 	
@@ -172,6 +209,6 @@
 	if (rc != EOK) {
 		fprintf(stderr, "Failed receiving response: %s\n", str_error(rc));
-		uri_destroy(uri);
-		return rc;
+		rc = EIO;
+		goto error;
 	}
 	
@@ -179,17 +216,15 @@
 		fprintf(stderr, "Server returned status %d %s\n", response->status,
 		    response->message);
-	}
-	else {
-		size_t buf_size = 4096;
-		void *buf = malloc(buf_size);
+	} else {
+		buf = malloc(buf_size);
 		if (buf == NULL) {
 			fprintf(stderr, "Failed allocating buffer\n)");
-			uri_destroy(uri);
-			return ENOMEM;
+			rc = ENOMEM;
+			goto error;
 		}
 		
 		int body_size;
 		while ((body_size = recv_buffer(&http->recv_buffer, buf, buf_size)) > 0) {
-			fwrite(buf, 1, body_size, stdout);
+			fwrite(buf, 1, body_size, ofile != NULL ? ofile : stdout);
 		}
 		
@@ -199,6 +234,22 @@
 	}
 	
+	free(buf);
+	http_destroy(http);
 	uri_destroy(uri);
+	if (ofile != NULL && fclose(ofile) != 0) {
+		printf("Error writing '%s'.\n", ofname);
+		return EIO;
+	}
+
 	return EOK;
+error:
+	free(buf);
+	if (http != NULL)
+		http_destroy(http);
+	if (uri != NULL)
+		uri_destroy(uri);
+	if (ofile != NULL)
+		fclose(ofile);
+	return rc;
 }
 
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/edit/edit.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,5 @@
 #include <macros.h>
 #include <clipboard.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 #include "sheet.h"
Index: uspace/app/edit/search.h
===================================================================
--- uspace/app/edit/search.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/edit/search.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 
 #include <str.h>
-#include <sys/types.h>
+#include <offset.h>
 
 struct search;
Index: uspace/app/fdisk/fdisk.c
===================================================================
--- uspace/app/fdisk/fdisk.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/fdisk/fdisk.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
  */
 
+#include <cap.h>
 #include <errno.h>
 #include <nchoice.h>
@@ -41,4 +42,6 @@
 #include <stdlib.h>
 #include <fdisk.h>
+
+#define NO_LABEL_CAPTION "(No name)"
 
 static bool quit = false;
@@ -149,5 +152,5 @@
 	nchoice_t *choice = NULL;
 	char *svcname = NULL;
-	fdisk_cap_t cap;
+	cap_spec_t cap;
 	fdisk_dev_info_t *sdev;
 	char *scap = NULL;
@@ -198,7 +201,7 @@
 		}
 
-		fdisk_cap_simplify(&cap);
-
-		rc = fdisk_cap_format(&cap, &scap);
+		cap_simplify(&cap);
+
+		rc = cap_format(&cap, &scap);
 		if (rc != EOK) {
 			assert(rc == ENOMEM);
@@ -443,6 +446,7 @@
 	int rc;
 	fdisk_part_spec_t pspec;
-	fdisk_cap_t cap;
-	fdisk_cap_t mcap;
+	cap_spec_t cap;
+	cap_spec_t mcap;
+	vol_label_supp_t vlsupp;
 	vol_fstype_t fstype = 0;
 	tinput_t *tinput = NULL;
@@ -450,4 +454,5 @@
 	char *scap;
 	char *smcap = NULL;
+	char *label = NULL;
 
 	if (pkind == lpk_logical)
@@ -462,7 +467,7 @@
 	}
 
-	fdisk_cap_simplify(&mcap);
-
-	rc = fdisk_cap_format(&mcap, &smcap);
+	cap_simplify(&mcap);
+
+	rc = cap_format(&mcap, &smcap);
 	if (rc != EOK) {
 		rc = ENOMEM;
@@ -486,5 +491,5 @@
 			goto error;
 
-		rc = fdisk_cap_parse(scap, &cap);
+		rc = cap_parse(scap, &cap);
 		if (rc == EOK)
 			break;
@@ -502,8 +507,31 @@
 	}
 
+	fdisk_get_vollabel_support(dev, fstype, &vlsupp);
+	if (vlsupp.supported) {
+		tinput = tinput_new();
+		if (tinput == NULL) {
+			rc = ENOMEM;
+			goto error;
+		}
+
+		rc = tinput_set_prompt(tinput, "?> ");
+		if (rc != EOK)
+			goto error;
+
+		/* Ask for volume label */
+		printf("Enter volume label for new partition.\n");
+		rc = tinput_read_i(tinput, "New volume", &label);
+		if (rc != EOK)
+			goto error;
+
+	    	tinput_destroy(tinput);
+		tinput = NULL;
+	}
+
 	fdisk_pspec_init(&pspec);
 	pspec.capacity = cap;
 	pspec.pkind = pkind;
 	pspec.fstype = fstype;
+	pspec.label = label;
 
 	rc = fdisk_part_create(dev, &pspec, NULL);
@@ -513,7 +541,9 @@
 	}
 
+	free(label);
 	return EOK;
 error:
 	free(smcap);
+	free(label);
 	if (tinput != NULL)
 		tinput_destroy(tinput);
@@ -530,4 +560,5 @@
 	char *sfstype = NULL;
 	char *sdesc = NULL;
+	const char *label;
 	bool confirm;
 	void *sel;
@@ -556,7 +587,7 @@
 		}
 
-		fdisk_cap_simplify(&pinfo.capacity);
-
-		rc = fdisk_cap_format(&pinfo.capacity, &scap);
+		cap_simplify(&pinfo.capacity);
+
+		rc = cap_format(&pinfo.capacity, &scap);
 		if (rc != EOK) {
 			printf("Out of memory.\n");
@@ -577,5 +608,11 @@
 			}
 
-			rc = asprintf(&sdesc, "%s, %s, %s", scap, spkind, sfstype);
+			if (str_size(pinfo.label) > 0)
+				label = pinfo.label;
+			else
+				label = "(No name)";
+
+			rc = asprintf(&sdesc, "%s %s, %s, %s", label,
+			    scap, spkind, sfstype);
 			if (rc < 0) {
 				rc = ENOMEM;
@@ -667,6 +704,6 @@
 	fdisk_part_t *part;
 	fdisk_part_info_t pinfo;
-	fdisk_cap_t cap;
-	fdisk_cap_t mcap;
+	cap_spec_t cap;
+	cap_spec_t mcap;
 	fdisk_dev_flags_t dflags;
 	char *sltype = NULL;
@@ -677,4 +714,5 @@
 	char *svcname = NULL;
 	char *spkind;
+	const char *label;
 	int rc;
 	int npart;
@@ -701,7 +739,7 @@
 	}
 
-	fdisk_cap_simplify(&cap);
-
-	rc = fdisk_cap_format(&cap, &sdcap);
+	cap_simplify(&cap);
+
+	rc = cap_format(&cap, &sdcap);
 	if (rc != EOK) {
 		printf("Out of memory.\n");
@@ -717,5 +755,5 @@
 	fdisk_dev_get_flags(dev, &dflags);
 
-	printf("Device: %s, %s\n", sdcap, svcname);
+	printf("Device: %s (%s)\n", svcname, sdcap);
 	free(sdcap);
 	sdcap = NULL;
@@ -755,7 +793,7 @@
 		}
 
-		fdisk_cap_simplify(&pinfo.capacity);
-
-		rc = fdisk_cap_format(&pinfo.capacity, &scap);
+		cap_simplify(&pinfo.capacity);
+
+		rc = cap_format(&pinfo.capacity, &scap);
 		if (rc != EOK) {
 			printf("Out of memory.\n");
@@ -769,8 +807,13 @@
 		}
 
+		if (str_size(pinfo.label) > 0)
+			label = pinfo.label;
+		else
+			label = "(No name)";
+
 		if (linfo.ltype == lt_none)
-			printf("Entire disk: %s", scap);
+			printf("Entire disk: %s %s", label, scap);
 		else
-			printf("Partition %d: %s", npart, scap);
+			printf("Partition %d: %s %s", npart, label, scap);
 
 		if ((linfo.flags & lf_ext_supp) != 0) {
@@ -807,7 +850,7 @@
 		}
 
-		fdisk_cap_simplify(&mcap);
-
-		rc = fdisk_cap_format(&mcap, &smcap);
+		cap_simplify(&mcap);
+
+		rc = cap_format(&mcap, &smcap);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -829,7 +872,7 @@
 		}
 
-		fdisk_cap_simplify(&mcap);
-
-		rc = fdisk_cap_format(&mcap, &smcap);
+		cap_simplify(&mcap);
+
+		rc = cap_format(&mcap, &smcap);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -854,7 +897,7 @@
 		}
 
-		fdisk_cap_simplify(&mcap);
-
-		rc = fdisk_cap_format(&mcap, &smcap);
+		cap_simplify(&mcap);
+
+		rc = cap_format(&mcap, &smcap);
 		if (rc != EOK) {
 			rc = ENOMEM;
@@ -872,7 +915,7 @@
 		}
 
-		fdisk_cap_simplify(&mcap);
-
-		rc = fdisk_cap_format(&mcap, &smcap);
+		cap_simplify(&mcap);
+
+		rc = cap_format(&mcap, &smcap);
 		if (rc != EOK) {
 			rc = ENOMEM;
Index: uspace/app/fontviewer/fontviewer.c
===================================================================
--- uspace/app/fontviewer/fontviewer.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/fontviewer/fontviewer.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -78,5 +78,5 @@
 				points += increment;
 		
-			if ((event->key == KC_DOWN)) {
+			if (event->key == KC_DOWN) {
 				if (points <= increment) {
 					points = 1;
Index: uspace/app/gunzip/Makefile
===================================================================
--- uspace/app/gunzip/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/app/gunzip/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2017 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = gunzip
+
+EXTRA_CFLAGS += -I$(LIBCOMPRESS_PREFIX)
+LIBS = $(LIBCOMPRESS_PREFIX)/libcompress.a
+
+SOURCES = \
+	gunzip.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/gunzip/gunzip.c
===================================================================
--- uspace/app/gunzip/gunzip.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/app/gunzip/gunzip.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,127 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gunzip
+ * @{
+ */
+/** @file
+ */
+
+#include <errno.h>
+#include <gzip.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+int main(int argc, char *argv[])
+{
+	int rc;
+	void *data, *ddata;
+	size_t size, dsize;
+	size_t nread, nwr;
+	long len;
+	FILE *f, *wf;
+
+	if (argc != 3) {
+		printf("syntax: gunzip <src.gz> <dest>\n");
+		return 1;
+	}
+
+	f = fopen(argv[1], "rb");
+	if (f == NULL) {
+		printf("Error opening '%s'\n", argv[1]);
+		return 1;
+	}
+
+	rc = fseek(f, 0, SEEK_END);
+	if (rc != 0) {
+		printf("Error determining size of '%s'\n", argv[1]);
+		fclose(f);
+		return 1;
+	}
+
+	len = ftell(f);
+	if (len < 0) {
+		printf("Error determining size of '%s'\n", argv[1]);
+		fclose(f);
+		return 1;
+	}
+
+	rc = fseek(f, 0, SEEK_SET);
+	if (rc != 0) {
+		printf ("Error rewinding '%s'\n", argv[1]);
+		fclose(f);
+		return 1;
+	}
+
+	data = malloc(len);
+	if (data == NULL) {
+		printf("Error allocating %ld bytes.\n", len);
+		fclose(f);
+		return 1;
+	}
+
+	nread = fread(data, 1, len, f);
+	if (nread != (size_t)len) {
+		printf("Error reading '%s'\n", argv[1]);
+		fclose(f);
+		return 1;
+	}
+
+	fclose(f);
+
+	size = (size_t) len;
+
+	rc = gzip_expand(data, size, &ddata, &dsize);
+	if (rc != EOK) {
+		printf("Error decompressing data.\n");
+		return 1;
+	}
+
+	wf = fopen(argv[2], "wb");
+	if (wf == NULL) {
+		printf("Error creating file '%s'\n", argv[2]);
+		return 1;
+	}
+
+	nwr = fwrite(ddata, 1, dsize, wf);
+	if (nwr != dsize) {
+		printf("Error writing '%s'\n", argv[2]);
+		fclose(wf);
+		return 1;
+	}
+
+	if (fclose(wf) != 0) {
+		printf("Error writing '%s'\n", argv[2]);
+		return 1;
+	}
+
+	return 0;
+}
+
+/** @}
+ */
